******************************************************
*  Program...........: classes.prg
*  Author............: Lauren Clarke
*  Created...........: 06/4/2001
*  Project...........: FT Decorator article
*  Description.......: This code repos some odd behavior in VFP when using
*					   access/assing methods in conjunction with WITH/ENDWITH
*                      The results are different under VFP6 and VFP7 Beta 1
******************************************************

clear

o= CREATE("WithTest")

? "------- DOT ----------"
o.prop1="Hi"
? o.Prop1
o.SomeMethod()
?
? "------- WITH ----------"

WITH o
  .prop1="Howareya?"
? .Prop1
 .SomeMethod()
ENDWITH



DEFINE CLASS WithTest as RELATION

Prop1 = ''

FUNCTION THIS_ACCESS( tMember)
? "THIS_ACCESS: "+tMember
RETURN THIS

FUNCTION Prop1_ASSIGN( tvValue)
? "Prop1_ASSIGN: "+tvValue
This.prop1= tvValue

FUNCTION Prop1_ACCESS
? "Prop1_ACCESS"
RETURN This.Prop1

FUNCTION SomeMethod()
? "SomeMethod is fired"

ENDDEFINE
